VERSION 5.00
Begin VB.Form frmHexView 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Editor Hexadecimal"
   ClientHeight    =   4950
   ClientLeft      =   45
   ClientTop       =   735
   ClientWidth     =   7785
   Icon            =   "frmHexView.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4950
   ScaleWidth      =   7785
   StartUpPosition =   2  'CenterScreen
   Begin VB.ListBox List1 
      Appearance      =   0  'Flat
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   4980
      Left            =   -10
      TabIndex        =   0
      Top             =   -10
      Width           =   7815
   End
   Begin VB.Menu mnuOptions 
      Caption         =   "Opes"
      Begin VB.Menu mnuViewPRG 
         Caption         =   "Exibir PRG"
      End
      Begin VB.Menu mnuViewCHR 
         Caption         =   "Exibir CHR"
      End
      Begin VB.Menu t3 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditLine 
         Caption         =   "Editar linha"
      End
      Begin VB.Menu t2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuSearch 
         Caption         =   "Procurar"
         Shortcut        =   ^F
      End
      Begin VB.Menu t1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuCopy 
         Caption         =   "Copiar tudo"
         Shortcut        =   ^C
      End
   End
   Begin VB.Menu mnuExit 
      Caption         =   "Fechar"
   End
End
Attribute VB_Name = "frmHexView"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'+======================+
'| Yoshi Nes Hex Editor |
'+======================+

Dim LoopCount As Long
Dim TempCount As Long

Dim hNums As String
Dim hChars As String

Dim TmpPrgCount As Long
Dim TmpChrCount As Long

Dim InView As String
Private Sub Form_Unload(Cancel As Integer)
    mnuExit_Click
End Sub
Private Sub Form_Load()
    TmpPrgCount = PrgCount
    TmpChrCount = ChrCount
End Sub
Private Sub List1_DblClick()
    mnuEditLine_Click
End Sub
Private Sub mnuCopy_Click()
    On Error GoTo ErrH
    Dim mTempCopy As String
    mTempCopy = ""
    For n = 0 To List1.ListCount - 1
        List1.ListIndex = n
        mTempCopy = mTempCopy & List1.Text & vbCrLf
    Next n
    Clipboard.SetText (mTempCopy)
    MsgBox "Texto copiado!", vbInformation, "Aviso"
ErrH:
End Sub
Private Sub mnuEditLine_Click()
    On Error GoTo ErrH
    Dim OldLine As String
    Dim NewLine As String
    Dim SelLine As Long
    
    If InView = "CHR" Then
        SelLine = List1.ListIndex - 3
        OldLine = Left(Right(List1.Text, 18), 16)
        NewLine = InputBox("Digite o que voc deseja alterar", "Alterar linha", Left(Right(List1.Text, 18), 16))
        If Len(NewLine) <> 16 Then Exit Sub
        For n = 1 To 16
            If Mid(NewLine, n, 1) <> Mid(OldLine, n, 1) Then
                VROM((16 * SelLine) + (n - 1)) = Asc(Mid(NewLine, n, 1))
            End If
        Next n
    Else
        SelLine = List1.ListIndex - 3
        OldLine = Left(Right(List1.Text, 18), 16)
        NewLine = InputBox("Digite o que voc deseja alterar", "Alterar linha", Left(Right(List1.Text, 18), 16))
        If Len(NewLine) <> 16 Then Exit Sub
        For n = 1 To 16
            If Mid(NewLine, n, 1) <> Mid(OldLine, n, 1) Then
                GameImage((16 * SelLine) + (n - 1)) = Asc(Mid(NewLine, n, 1))
            End If
        Next n
    End If
    If NewLine <> OldLine Then
        If InView = "CHR" Then
            mnuViewCHR_Click
        Else
            mnuViewPRG_Click
        End If
    End If
ErrH:
End Sub
Private Sub mnuExit_Click()
    On Error GoTo ErrH
    ' Force the loops to stop
    LoopCount = UBound(VROM)
    LoopCount = UBound(GameImage)
    ' Don't draw the final line
    TmpPrgCount = 0
    TmpChrCount = 0
    ' Clear the list
    List1.Clear
ErrH:
    ' And exit
    If CPUPaused = True Then frmNES.mnuCPUPause_Click
    Unload frmHexView
End Sub
Private Sub mnuSearch_Click()
    On Error GoTo ErrH
    Dim SearchStr As String

    SearchStr = InputBox("O que voc deseja pesquisar?", "Buscar", "")
    List1.ListIndex = 0
    For n = 0 To List1.ListCount - 1
        List1.ListIndex = n
        If InStr(List1.Text, SearchStr) Then GoTo ErrH
    Next n
    MsgBox "Texto no encontrado!", vbInformation, "Busca"
ErrH:
End Sub
Private Sub mnuViewCHR_Click()
    On Error GoTo ErrH
    InView = "CHR"
    List1.Clear
    hNums = ""
    hChars = ""
    TempCount = 0
    LoopCount = 0
    
    If TmpChrCount <> 0 Then
        List1.AddItem "+-------------------------------------------------+------------------+"
        List1.AddItem "|*                      Hex                      *|*      Ascii     *|"
        List1.AddItem "+-------------------------------------------------+------------------+"
    End If
    Do
        hNums = hNums & FixHex(Hex(VROM(LoopCount))) & " "
        If VROM(LoopCount) > 32 And VROM(LoopCount) < 127 Then
            hChars = hChars & Chr(VROM(LoopCount))
        Else
            hChars = hChars & " "
        End If
        TempCount = TempCount + 1
        LoopCount = LoopCount + 1
        If TempCount = 16 Then
            TempCount = 0
            List1.AddItem "| " & hNums & "| " & hChars & " |"
            hNums = ""
            hChars = ""
        End If
        DoEvents
    Loop Until LoopCount >= UBound(VROM)
    If TmpChrCount <> 0 Then List1.AddItem "+-------------------------------------------------+------------------+"
ErrH:
End Sub
Private Sub mnuViewPRG_Click()
    On Error GoTo ErrH
    InView = "PRG"
    List1.Clear
    hNums = ""
    hChars = ""
    TempCount = 0
    LoopCount = 0
    
    If TmpPrgCount <> 0 Then
        List1.AddItem "+-------------------------------------------------+------------------+"
        List1.AddItem "|*                      Hex                      *|*      Ascii     *|"
        List1.AddItem "+-------------------------------------------------+------------------+"
    End If
    Do
        hNums = hNums & FixHex(Hex(GameImage(LoopCount))) & " "
        If GameImage(LoopCount) > 32 And GameImage(LoopCount) < 127 Then
            hChars = hChars & Chr(GameImage(LoopCount))
        Else
            hChars = hChars & " "
        End If
        TempCount = TempCount + 1
        LoopCount = LoopCount + 1
        If TempCount = 16 Then
            TempCount = 0
            List1.AddItem "| " & hNums & "| " & hChars & " |"
            hNums = ""
            hChars = ""
        End If
        DoEvents
    Loop Until LoopCount >= UBound(GameImage)
    If TmpPrgCount <> 0 Then List1.AddItem "+-------------------------------------------------+------------------+"
ErrH:
End Sub
