VERSION 5.00
Begin VB.Form frmPattern 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Pattern Tables"
   ClientHeight    =   3840
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   7680
   Icon            =   "frmPattern.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   256
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   512
   StartUpPosition =   2  'CenterScreen
   Begin VB.PictureBox PicPatt 
      AutoRedraw      =   -1  'True
      BorderStyle     =   0  'None
      Height          =   3840
      Left            =   0
      ScaleHeight     =   256
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   512
      TabIndex        =   0
      Top             =   0
      Width           =   7680
      Begin VB.Timer Timer1 
         Interval        =   1
         Left            =   360
         Top             =   240
      End
   End
End
Attribute VB_Name = "frmPattern"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim mRgb(2) As Byte
Dim isDrawingPat As Boolean
Dim DrawPal(3) As Long
Dim StartPoint As Long
Dim RandColor As Boolean
Private Sub Form_Load()
    PatternTables
End Sub
Sub PatternTables()
    On Error Resume Next
    'Draw Pattern Tables
    Dim VBytes As String
    Dim Tmp(7) As Long
    Dim a As Long
    
    If ChrCount = 0 Then Exit Sub
    
    isDrawingPat = True 'Started the draw
    
    'Get the first 4 colors of selected pallete colors
    If RandColor Then
        For i = 0 To 3
            MemCopy mRgb(0), pal(Int(Rnd * 255)), Len(pal(Int(Rnd * 255)))
            DrawPal(i) = RGB(mRgb(2), mRgb(1), mRgb(0))
        Next i
    Else
        For i = 0 To 3
            MemCopy mRgb(0), pal(VRAM(i + &H3F00)), Len(pal(VRAM(i + &H3F00)))
            DrawPal(i) = RGB(mRgb(2), mRgb(1), mRgb(0))
        Next i
    End If
    
    LoopCount = StartPoint
    Do 'Load only necessary VROM values to save time
        LoopCount = LoopCount + 1
        If ChrCount Then
            VBytes = VBytes & Chr(VROM(LoopCount))
        Else
            VBytes = VBytes & Chr(GameImage(LoopCount))
        End If
        DoEvents
    Loop Until LoopCount >= StartPoint + 8192
    VBytes = " " & VBytes
    a = 1
    For Table = 0 To 1
        For ty = 0 To 120 Step 8
            For tx = 0 To 120 Step 8
               For Y = 0 To 7
                    For planes = 0 To 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 128) = 128 Then Tmp(0) = Tmp(0) + planes + 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 64) = 64 Then Tmp(1) = Tmp(1) + planes + 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 32) = 32 Then Tmp(2) = Tmp(2) + planes + 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 16) = 16 Then Tmp(3) = Tmp(3) + planes + 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 8) = 8 Then Tmp(4) = Tmp(4) + planes + 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 4) = 4 Then Tmp(5) = Tmp(5) + planes + 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 2) = 2 Then Tmp(6) = Tmp(6) + planes + 1
                        If (Asc(Mid$(VBytes, a + planes * 8, 1)) And 1) = 1 Then Tmp(7) = Tmp(7) + planes + 1
                    Next planes
                    For bl = 0 To 7
                        PSet (Table * 128 + tx + bl, ty + Y), DrawPal(Tmp(bl))
                        Tmp(bl) = 0
                    Next bl
                    a = a + 1
               Next Y
               a = a + 8
            Next tx
        Next ty
    Next Table
    If RandColor Then
        For i = 0 To 3
            MemCopy mRgb(0), pal(VRAM(i + &H3F00)), Len(pal(VRAM(i + &H3F00)))
            DrawPal(i) = RGB(mRgb(2), mRgb(1), mRgb(0))
        Next i
    End If
    'Paint and Resize
    PicPatt.PaintPicture Me.Image, 0, 0, 1024, 512
    isDrawingPat = False
End Sub
Private Sub Timer1_Timer()
    'Update the sprite colors
    If Not isDrawingPat Then
        For i = 0 To 3 'Only update if color changed
            MemCopy mRgb(0), pal(VRAM(i + &H3F00)), Len(pal(VRAM(i + &H3F00)))
            If DrawPal(i) <> RGB(mRgb(2), mRgb(1), mRgb(0)) Then ChrCalc: PatternTables
        Next i
    End If
End Sub
Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyLeft Then
        If StartPoint >= 8192 Then StartPoint = StartPoint - 8192
        PatternTables
    End If
    If KeyCode = vbKeyRight Then
        StartPoint = StartPoint + 8192
        PatternTables
    End If
    If KeyCode = vbKeyControl Then
        RandColor = Not RandColor
        PatternTables
    End If
    If KeyCode = vbKeyF5 Then PatternTables
End Sub
Sub ChrCalc()
    'Strange Problems, this is a quick fix
    StartPoint = 0
    For i = 0 To (CurMMCVal) - 1
        StartPoint = StartPoint + 8192
    Next i
End Sub
