VERSION 5.00
Begin VB.Form frmROMInfo 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Informaes da ROM"
   ClientHeight    =   2055
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5415
   Icon            =   "frmROMInfo.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2055
   ScaleWidth      =   5415
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton cmdOK 
      Caption         =   "&OK"
      Default         =   -1  'True
      Height          =   345
      Left            =   1800
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   1560
      Width           =   1935
   End
   Begin VB.Label lblList 
      BackStyle       =   0  'Transparent
      BeginProperty Font 
         Name            =   "Lucida Console"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1215
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   4935
   End
End
Attribute VB_Name = "frmROMInfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Sub cmdOk_Click()
    Unload Me
End Sub
Private Sub Form_Load()
    On Error Resume Next
    Dim MType As String
    lblList.Caption = ""
    '****Memory****
    lblList.Caption = lblList.Caption & "PRG-ROM:      " & PrgCount * 16 & "k" & " (" & PrgCount & QFix(PrgCount) & ")" & vbCrLf
    lblList.Caption = lblList.Caption & "CHR-ROM:      " & ChrCount * 8 & "k" & " (" & ChrCount & QFix(ChrCount) & ")" & vbCrLf
    '****Mapper****
    lblList.Caption = lblList.Caption & "Mapper:       " & Mapper & " (" & MapperName(Mapper) & ")" & vbCrLf
    '****Mirroring****
    If Mirroring = 0 Then MType = "Horizontal"
    If Mirroring = 1 Then MType = "Vertical"
    If Mirroring = 2 Then MType = "One screen"
    If Mirroring = 4 Then MType = "Four screen"
    lblList.Caption = lblList.Caption & "Mirroring:    " & MType & vbCrLf
    '****Trainer****
    lblList.Caption = lblList.Caption & "Trainer:      " & IIf(Trainer, "Sim", "No") & vbCrLf
    '****Battery****
    lblList.Caption = lblList.Caption & "Battery:      " & IIf(Batt, "Sim", "No") & vbCrLf
    '****Checksum****
    lblList.Caption = lblList.Caption & "CRC32:        " & Checksum
    Show
End Sub
Public Function QFix(ByVal fCount As Long) As String
    If fCount = 1 Then QFix = " banco" Else QFix = " bancos"
End Function
Public Function MapperName(ByVal MN As Long) As String
    Dim A As String
    
    'Mapper Names
    Select Case MN
        Case 0: A = "Nenhum"
        Case 1: A = "Nitendo MMC1"
        Case 2: A = "UNROM"
        Case 3: A = "CNROM"
        Case 4: A = "Nitendo MMC3"
        Case 5: A = "Nitendo MMC5"
        Case 6: A = "FFE F4xxx"
        Case 7: A = "AOROM"
        Case 8: A = "FFE F3xxx"
        Case 9: A = "Nitendo MMC2"
        Case 10: A = "Nitendo MMC4"
        Case 11: A = "Colour Dreams"
        Case 16: A = "Bandai"
        Case 17: A = "FFE F8xxx"
        Case 18: A = "Jaleco SS8806"
        Case 19: A = "Namcot 106"
        Case 21: A = "Konami VRC4"
        Case 22: A = "Konami VRC2 tipo A"
        Case 23: A = "Konami VRC2 tipo B"
        Case 24: A = "Konami VRC6"
        Case 26: A = "Konami VRC6 2"
        Case 32: A = "Irem G101"
        Case 33: A = "Taito TC0190"
        Case 34: A = "Nina-1"
        Case 51: A = "11-in-1 Ball Games"
        Case 52: A = "Mario 7-in-1"
        Case 61: A = "20-in-1"
        Case 64: A = "Rambo-1"
        Case 65: A = "Irem H3001"
        Case 66: A = "GNROM"
        Case 68: A = "Sunsoft 4"
        Case 69: A = "Sunsoft 5"
        Case 71: A = "Camerica"
        Case 73: A = "Konami VRC3"
        Case 78: A = "Irem 74HC161/32"
        Case 79: A = "AVE"
        Case 83: A = "Cony"
        Case 90: A = "PCJY"
        Case 91: A = "HK-SF3"
        Case 95: A = "Namco 1xx"
        Case 99, 100, 151, 152: A = "VS-Unisystem"
        Case 105: A = "NWC 1990 MMC1 MOD"
        Case 119: A = "TQROM"
        Case 182: A = "SDK/LK Pirate"
        Case 200: A = "1200-in-1"
        Case 201: A = "21-in-1"
        Case 211: A = "JY Company"
        Case 212: A = "10000000-in-1"
        Case 227: A = "1200-in-1"
        Case 228: A = "Action 52"
        Case 231: A = "20-in-1"
        Case 232: A = "Quattro Games"
        Case 242: A = "Wai Xing Zhan Shi"
        Case 250: A = "Time Diver Avenger"
        Case 255: A = "110-in-1"
    End Select
    If A = "" Then MapperName = "Desconhecido" Else MapperName = A
End Function
