Attribute VB_Name = "modConfig"
Public Const ConfigFile = "YoshiNES.cfg" 'Configuration file.

'****************
'****Joypads*****
'****************

' Joypad 1
Public nes_ButA As Byte
Public nes_ButB As Byte
Public nes_ButSel As Byte
Public nes_ButSta As Byte
Public nes_ButUp As Byte
Public nes_ButDn As Byte
Public nes_ButLt As Byte
Public nes_ButRt As Byte

' Joypad 2
Public nes2_ButA As Byte
Public nes2_ButB As Byte
Public nes2_ButSel As Byte
Public nes2_ButSta As Byte
Public nes2_ButUp As Byte
Public nes2_ButDn As Byte
Public nes2_ButLt As Byte
Public nes2_ButRt As Byte

'****************
'****Gamepads****
'****************

' Gamepad 1
Public pad_ButA As Byte
Public pad_ButB As Byte
Public pad_ButSel As Byte
Public pad_ButSta As Byte

' Gamepad 2
Public pad2_ButA As Byte
Public pad2_ButB As Byte
Public pad2_ButSel As Byte
Public pad2_ButSta As Byte
Public Function LoadConfig() As Boolean
    On Error GoTo ErrH
    
    Dim FileNum As Integer
    FileNum = FreeFile
    Dim Tmp As String
    
    ChDir App.Path & "\"
    If Dir(ConfigFile) = "" Then
        MsgBox "Configurao no encontrada! Usando teclas padres!", vbExclamation, VERSION
        '****Configuraes padres****
        nes_ButA = vbKeyZ
        nes_ButB = vbKeyX
        nes_ButSel = vbKeyControl
        nes_ButSta = vbKeyReturn
        nes_ButUp = vbKeyUp
        nes_ButDn = vbKeyDown
        nes_ButLt = vbKeyLeft
        nes_ButRt = vbKeyRight
        nes2_ButA = vbKeyNumpad1
        nes2_ButB = vbKeyNumpad2
        nes2_ButSel = vbKeyNumpad7
        nes2_ButSta = vbKeyNumpad9
        nes2_ButUp = vbKeyNumpad8
        nes2_ButDn = vbKeyNumpad5
        nes2_ButLt = vbKeyNumpad4
        nes2_ButRt = vbKeyNumpad6
        pad_ButA = 0
        pad_ButB = 0
        pad_ButSel = 0
        pad_ButSta = 0
        pad2_ButA = 0
        pad2_ButB = 0
        pad2_ButSel = 0
        pad2_ButSta = 0
        LoadConfig = False
        Exit Function
    End If
    
    Open ConfigFile For Input As #FileNum
        Line Input #FileNum, Tmp
        Line Input #FileNum, Tmp: nes_ButA = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes_ButB = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes_ButSel = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes_ButSta = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes_ButUp = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes_ButDn = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes_ButLt = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes_ButRt = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButA = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButB = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButSel = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButSta = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButUp = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButDn = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButLt = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: nes2_ButRt = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: Gamepad1 = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: Gamepad2 = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad_ButA = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad_ButB = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad_ButSel = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad_ButSta = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad2_ButA = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad2_ButB = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad2_ButSel = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: pad2_ButSta = CByte(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mnuCh1.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mnuCh2.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mnuCh3.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mnuCh4.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mLayer1.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mLayer2.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mnuIgnoreErrors.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mnuShowStatus.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.mnuCut.Checked = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: frmNES.PicScreen.Width = Right(Tmp, Len(Tmp) - 30)
        Line Input #FileNum, Tmp: frmNES.PicScreen.Height = Right(Tmp, Len(Tmp) - 30)
        Line Input #FileNum, Tmp: SaveCPU = CBool(Right(Tmp, Len(Tmp) - 30))
        Line Input #FileNum, Tmp: Recents(0) = Right(Tmp, Len(Tmp) - 30)
        Line Input #FileNum, Tmp: Recents(1) = Right(Tmp, Len(Tmp) - 30)
        Line Input #FileNum, Tmp: Recents(2) = Right(Tmp, Len(Tmp) - 30)
        Line Input #FileNum, Tmp: Recents(3) = Right(Tmp, Len(Tmp) - 30)
        Line Input #FileNum, Tmp: Recents(4) = Right(Tmp, Len(Tmp) - 30)
        For i = 0 To 3
            Line Input #FileNum, Tmp
            Instrumental(i) = Val(Tmp)
            SelectInstrument i, Val(Tmp)
        Next i
        If Instrumental(0) + Instrumental(1) + Instrumental(2) + Instrumental(3) = 0 Then pAPUinit
        If EOF(FileNum) = False Then
            Line Input #FileNum, palName
        End If
    Close #FileNum
    
    If Gamepad1 = 1 Or Gamepad2 = 1 Then frmNES.Timer3.Enabled = True
    LoadConfig = True
    frmNES.ResScreen
    Exit Function
ErrH:
    MsgBox "Erro ao carregar a configurao!", vbCritical, "Erro!"
End Function
Public Function SaveConfig()
    On Error GoTo ErrH
    
    ChDir App.Path & "\"
    Dim FileNum As Integer
    FileNum = FreeFile
    
    Open ConfigFile For Output As #FileNum
        Print #FileNum, "[YoshiNES Config File]"
        Print #FileNum, "NES Control 1 BUT A KEYCODE = " & nes_ButA
        Print #FileNum, "NES Control 1 BUT B KEYCODE = " & nes_ButB
        Print #FileNum, "NES Control 1 SELEC KEYCODE = " & nes_ButSel
        Print #FileNum, "NES Control 1 START KEYCODE = " & nes_ButSta
        Print #FileNum, "NES Control 1 CIMA KEYCODE  = " & nes_ButUp
        Print #FileNum, "NES Control 1 BAIXO KEYCODE = " & nes_ButDn
        Print #FileNum, "NES Control 1 ESQ KEYCODE =   " & nes_ButLt
        Print #FileNum, "NES Control 1 DIR KEYCODE =   " & nes_ButRt
        Print #FileNum, "NES Control 2 BUT A KEYCODE = " & nes2_ButA
        Print #FileNum, "NES Control 2 BUT B KEYCODE = " & nes2_ButB
        Print #FileNum, "NES Control 2 SELEC KEYCODE = " & nes2_ButSel
        Print #FileNum, "NES Control 2 START KEYCODE = " & nes2_ButSta
        Print #FileNum, "NES Control 2 CIMA KEYCODE  = " & nes2_ButUp
        Print #FileNum, "NES Control 2 BAIXO KEYCODE = " & nes2_ButDn
        Print #FileNum, "NES Control 2 ESQ KEYCODE =   " & nes2_ButLt
        Print #FileNum, "NES Control 2 DIR KEYCODE =   " & nes2_ButRt
        Print #FileNum, "USE GAMEPAD 1 FALSE/TRUE =    " & Gamepad1
        Print #FileNum, "USE GAMEPAD 2 FALSE/TRUE =    " & Gamepad2
        Print #FileNum, "GAMEPAD 1 BUT A =             " & pad_ButA
        Print #FileNum, "GAMEPAD 1 BUT B =             " & pad_ButB
        Print #FileNum, "GAMEPAD 1 BUT SELEC =         " & pad_ButSel
        Print #FileNum, "GAMEPAD 1 BUT START =         " & pad_ButSta
        Print #FileNum, "GAMEPAD 2 BUT A =             " & pad2_ButA
        Print #FileNum, "GAMEPAD 2 BUT B =             " & pad2_ButB
        Print #FileNum, "GAMEPAD 2 BUT SELEC =         " & pad2_ButSel
        Print #FileNum, "GAMEPAD 2 BUT START =         " & pad2_ButSta
        Print #FileNum, "CANAL DE AUDIO 1 FALSE/TRUE = " & rVal(frmNES.mnuCh1.Checked)
        Print #FileNum, "CANAL DE AUDIO 2 FALSE/TRUE = " & rVal(frmNES.mnuCh2.Checked)
        Print #FileNum, "CANAL DE AUDIO 3 FALSE/TRUE = " & rVal(frmNES.mnuCh3.Checked)
        Print #FileNum, "CANAL DE AUDIO 4 FALSE/TRUE = " & rVal(frmNES.mnuCh4.Checked)
        Print #FileNum, "CAMADA VIDEO 1 FALSE/TRUE =   " & rVal(frmNES.mLayer1.Checked)
        Print #FileNum, "CAMADA VIDEO 2 FALSE/TRUE =   " & rVal(frmNES.mLayer2.Checked)
        Print #FileNum, "INGORAR ERROS FALSE/TRUE =    " & rVal(frmNES.mnuIgnoreErrors.Checked)
        Print #FileNum, "EXIBIR STATUS FALSE/TRUE =    " & rVal(frmNES.mnuShowStatus.Checked)
        Print #FileNum, "CORTAR BORDA 8px FALSE/TRUE = " & rVal(frmNES.mnuCut.Checked)
        Print #FileNum, "NES VIDEO WIDTH =             " & frmNES.PicScreen.Width
        Print #FileNum, "NES VIDEO HEIGHT =            " & frmNES.PicScreen.Height
        Print #FileNum, "CPU INTELIGENTE SMART =       " & rVal(SaveCPU)
        Print #FileNum, "RECENT SLOT #1 =              " & Recents(0)
        Print #FileNum, "RECENT SLOT #2 =              " & Recents(1)
        Print #FileNum, "RECENT SLOT #3 =              " & Recents(2)
        Print #FileNum, "RECENT SLOT #4 =              " & Recents(3)
        Print #FileNum, "RECENT SLOT #5 =              " & Recents(4)
        For i = 0 To 3
            Print #FileNum, Instrumental(i)
        Next i
        Print #FileNum, palName
    Close #FileNum
    Exit Function
ErrH:
    MsgBox "Erro ao salvar a configurao!", vbCritical, "Erro!"
End Function
Public Function rVal(Bol As Boolean) As Integer
    If Bol Then rVal = 1 Else rVal = 0
End Function
